<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfETCouponCheckin ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfETCouponCheckin
 * @subpackage Arrays
 */
class ArrayOfETCouponCheckin extends AbstractStructArrayBase
{
    /**
     * The ETCouponCheckin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ETCouponCheckin[]
     */
    public $ETCouponCheckin;
    /**
     * Constructor method for ArrayOfETCouponCheckin
     * @uses ArrayOfETCouponCheckin::setETCouponCheckin()
     * @param \App|C\StructType\ETCouponCheckin[] $eTCouponCheckin
     */
    public function __construct(array $eTCouponCheckin = array())
    {
        $this
            ->setETCouponCheckin($eTCouponCheckin);
    }
    /**
     * Get ETCouponCheckin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ETCouponCheckin[]|null
     */
    public function getETCouponCheckin()
    {
        return isset($this->ETCouponCheckin) ? $this->ETCouponCheckin : null;
    }
    /**
     * This method is responsible for validating the values passed to the setETCouponCheckin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setETCouponCheckin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateETCouponCheckinForArrayConstraintsFromSetETCouponCheckin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfETCouponCheckinETCouponCheckinItem) {
            // validation for constraint: itemType
            if (!$arrayOfETCouponCheckinETCouponCheckinItem instanceof \App|C\StructType\ETCouponCheckin) {
                $invalidValues[] = is_object($arrayOfETCouponCheckinETCouponCheckinItem) ? get_class($arrayOfETCouponCheckinETCouponCheckinItem) : sprintf('%s(%s)', gettype($arrayOfETCouponCheckinETCouponCheckinItem), var_export($arrayOfETCouponCheckinETCouponCheckinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ETCouponCheckin property can only contain items of type \App|C\StructType\ETCouponCheckin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ETCouponCheckin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETCouponCheckin[] $eTCouponCheckin
     * @return \App|C\ArrayType\ArrayOfETCouponCheckin
     */
    public function setETCouponCheckin(array $eTCouponCheckin = array())
    {
        // validation for constraint: array
        if ('' !== ($eTCouponCheckinArrayErrorMessage = self::validateETCouponCheckinForArrayConstraintsFromSetETCouponCheckin($eTCouponCheckin))) {
            throw new \InvalidArgumentException($eTCouponCheckinArrayErrorMessage, __LINE__);
        }
        if (is_null($eTCouponCheckin) || (is_array($eTCouponCheckin) && empty($eTCouponCheckin))) {
            unset($this->ETCouponCheckin);
        } else {
            $this->ETCouponCheckin = $eTCouponCheckin;
        }
        return $this;
    }
    /**
     * Add item to ETCouponCheckin value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETCouponCheckin $item
     * @return \App|C\ArrayType\ArrayOfETCouponCheckin
     */
    public function addToETCouponCheckin(\App|C\StructType\ETCouponCheckin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ETCouponCheckin) {
            throw new \InvalidArgumentException(sprintf('The ETCouponCheckin property can only contain items of type \App|C\StructType\ETCouponCheckin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ETCouponCheckin[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ETCouponCheckin|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ETCouponCheckin|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ETCouponCheckin|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ETCouponCheckin|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ETCouponCheckin|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ETCouponCheckin
     */
    public function getAttributeName()
    {
        return 'ETCouponCheckin';
    }
}
