<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatDeck ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatDeck
 * @subpackage Arrays
 */
class ArrayOfSeatDeck extends AbstractStructArrayBase
{
    /**
     * The SeatDeck
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\SeatDeck[]
     */
    public $SeatDeck;
    /**
     * Constructor method for ArrayOfSeatDeck
     * @uses ArrayOfSeatDeck::setSeatDeck()
     * @param \App|C\StructType\SeatDeck[] $seatDeck
     */
    public function __construct(array $seatDeck = array())
    {
        $this
            ->setSeatDeck($seatDeck);
    }
    /**
     * Get SeatDeck value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\SeatDeck[]|null
     */
    public function getSeatDeck()
    {
        return isset($this->SeatDeck) ? $this->SeatDeck : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatDeck method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatDeck method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatDeckForArrayConstraintsFromSetSeatDeck(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatDeckSeatDeckItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatDeckSeatDeckItem instanceof \App|C\StructType\SeatDeck) {
                $invalidValues[] = is_object($arrayOfSeatDeckSeatDeckItem) ? get_class($arrayOfSeatDeckSeatDeckItem) : sprintf('%s(%s)', gettype($arrayOfSeatDeckSeatDeckItem), var_export($arrayOfSeatDeckSeatDeckItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatDeck property can only contain items of type \App|C\StructType\SeatDeck, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatDeck value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SeatDeck[] $seatDeck
     * @return \App|C\ArrayType\ArrayOfSeatDeck
     */
    public function setSeatDeck(array $seatDeck = array())
    {
        // validation for constraint: array
        if ('' !== ($seatDeckArrayErrorMessage = self::validateSeatDeckForArrayConstraintsFromSetSeatDeck($seatDeck))) {
            throw new \InvalidArgumentException($seatDeckArrayErrorMessage, __LINE__);
        }
        if (is_null($seatDeck) || (is_array($seatDeck) && empty($seatDeck))) {
            unset($this->SeatDeck);
        } else {
            $this->SeatDeck = $seatDeck;
        }
        return $this;
    }
    /**
     * Add item to SeatDeck value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SeatDeck $item
     * @return \App|C\ArrayType\ArrayOfSeatDeck
     */
    public function addToSeatDeck(\App|C\StructType\SeatDeck $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\SeatDeck) {
            throw new \InvalidArgumentException(sprintf('The SeatDeck property can only contain items of type \App|C\StructType\SeatDeck, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatDeck[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\SeatDeck|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\SeatDeck|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\SeatDeck|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\SeatDeck|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\SeatDeck|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatDeck
     */
    public function getAttributeName()
    {
        return 'SeatDeck';
    }
}
