<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LoadMCOTicketsResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:LoadMCOTicketsResponse
 * @subpackage Structs
 */
class LoadMCOTicketsResponse extends AbstractResponse
{
    /**
     * The LoadMCOTicketsResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\LoadMCOTicketsResponse
     */
    public $LoadMCOTicketsResult;
    /**
     * The MCOTickets
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfMCOTicket
     */
    public $MCOTickets;
    /**
     * Constructor method for LoadMCOTicketsResponse
     * @uses LoadMCOTicketsResponse::setLoadMCOTicketsResult()
     * @uses LoadMCOTicketsResponse::setMCOTickets()
     * @param \App|C\StructType\LoadMCOTicketsResponse $loadMCOTicketsResult
     * @param \App|C\ArrayType\ArrayOfMCOTicket $mCOTickets
     */
    public function __construct(\App|C\StructType\LoadMCOTicketsResponse $loadMCOTicketsResult = null, \App|C\ArrayType\ArrayOfMCOTicket $mCOTickets = null)
    {
        $this
            ->setLoadMCOTicketsResult($loadMCOTicketsResult)
            ->setMCOTickets($mCOTickets);
    }
    /**
     * Get LoadMCOTicketsResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\LoadMCOTicketsResponse|null
     */
    public function getLoadMCOTicketsResult()
    {
        return isset($this->LoadMCOTicketsResult) ? $this->LoadMCOTicketsResult : null;
    }
    /**
     * Set LoadMCOTicketsResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\LoadMCOTicketsResponse $loadMCOTicketsResult
     * @return \App|C\StructType\LoadMCOTicketsResponse
     */
    public function setLoadMCOTicketsResult(\App|C\StructType\LoadMCOTicketsResponse $loadMCOTicketsResult = null)
    {
        if (is_null($loadMCOTicketsResult) || (is_array($loadMCOTicketsResult) && empty($loadMCOTicketsResult))) {
            unset($this->LoadMCOTicketsResult);
        } else {
            $this->LoadMCOTicketsResult = $loadMCOTicketsResult;
        }
        return $this;
    }
    /**
     * Get MCOTickets value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfMCOTicket|null
     */
    public function getMCOTickets()
    {
        return isset($this->MCOTickets) ? $this->MCOTickets : null;
    }
    /**
     * Set MCOTickets value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfMCOTicket $mCOTickets
     * @return \App|C\StructType\LoadMCOTicketsResponse
     */
    public function setMCOTickets(\App|C\ArrayType\ArrayOfMCOTicket $mCOTickets = null)
    {
        if (is_null($mCOTickets) || (is_array($mCOTickets) && empty($mCOTickets))) {
            unset($this->MCOTickets);
        } else {
            $this->MCOTickets = $mCOTickets;
        }
        return $this;
    }
}
