<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PartnerInformation StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PartnerInformation
 * @subpackage Structs
 */
class PartnerInformation extends AbstractStructBase
{
    /**
     * The HasPartners
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $HasPartners;
    /**
     * Constructor method for PartnerInformation
     * @uses PartnerInformation::setHasPartners()
     * @param bool $hasPartners
     */
    public function __construct($hasPartners = null)
    {
        $this
            ->setHasPartners($hasPartners);
    }
    /**
     * Get HasPartners value
     * @return bool|null
     */
    public function getHasPartners()
    {
        return $this->HasPartners;
    }
    /**
     * Set HasPartners value
     * @param bool $hasPartners
     * @return \App|C\StructType\PartnerInformation
     */
    public function setHasPartners($hasPartners = null)
    {
        // validation for constraint: boolean
        if (!is_null($hasPartners) && !is_bool($hasPartners)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($hasPartners, true), gettype($hasPartners)), __LINE__);
        }
        $this->HasPartners = $hasPartners;
        return $this;
    }
}
