<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrepareFlightsRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PrepareFlightsRequest
 * @subpackage Structs
 */
class PrepareFlightsRequest extends AbstractRequest
{
    /**
     * The DeferredIssuance
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $DeferredIssuance;
    /**
     * The ECouponBookCodes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfECouponBookCode
     */
    public $ECouponBookCodes;
    /**
     * The FareInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareInfo
     */
    public $FareInfo;
    /**
     * The IncludeAllOptionalSpecialServices
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IncludeAllOptionalSpecialServices;
    /**
     * The Offer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\OfferIn
     */
    public $Offer;
    /**
     * The Passengers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfPassenger
     */
    public $Passengers;
    /**
     * The PromoCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PromoCode;
    /**
     * The Segments
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfSegmentBooking
     */
    public $Segments;
    /**
     * The WebClassesCodes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfstring
     */
    public $WebClassesCodes;
    /**
     * Constructor method for PrepareFlightsRequest
     * @uses PrepareFlightsRequest::setDeferredIssuance()
     * @uses PrepareFlightsRequest::setECouponBookCodes()
     * @uses PrepareFlightsRequest::setFareInfo()
     * @uses PrepareFlightsRequest::setIncludeAllOptionalSpecialServices()
     * @uses PrepareFlightsRequest::setOffer()
     * @uses PrepareFlightsRequest::setPassengers()
     * @uses PrepareFlightsRequest::setPromoCode()
     * @uses PrepareFlightsRequest::setSegments()
     * @uses PrepareFlightsRequest::setWebClassesCodes()
     * @param bool $deferredIssuance
     * @param \App|C\ArrayType\ArrayOfECouponBookCode $eCouponBookCodes
     * @param \App|C\StructType\FareInfo $fareInfo
     * @param bool $includeAllOptionalSpecialServices
     * @param \App|C\StructType\OfferIn $offer
     * @param \App|C\ArrayType\ArrayOfPassenger $passengers
     * @param string $promoCode
     * @param \App|C\ArrayType\ArrayOfSegmentBooking $segments
     * @param \App|C\ArrayType\ArrayOfstring $webClassesCodes
     */
    public function __construct($deferredIssuance = null, \App|C\ArrayType\ArrayOfECouponBookCode $eCouponBookCodes = null, \App|C\StructType\FareInfo $fareInfo = null, $includeAllOptionalSpecialServices = null, \App|C\StructType\OfferIn $offer = null, \App|C\ArrayType\ArrayOfPassenger $passengers = null, $promoCode = null, \App|C\ArrayType\ArrayOfSegmentBooking $segments = null, \App|C\ArrayType\ArrayOfstring $webClassesCodes = null)
    {
        $this
            ->setDeferredIssuance($deferredIssuance)
            ->setECouponBookCodes($eCouponBookCodes)
            ->setFareInfo($fareInfo)
            ->setIncludeAllOptionalSpecialServices($includeAllOptionalSpecialServices)
            ->setOffer($offer)
            ->setPassengers($passengers)
            ->setPromoCode($promoCode)
            ->setSegments($segments)
            ->setWebClassesCodes($webClassesCodes);
    }
    /**
     * Get DeferredIssuance value
     * @return bool|null
     */
    public function getDeferredIssuance()
    {
        return $this->DeferredIssuance;
    }
    /**
     * Set DeferredIssuance value
     * @param bool $deferredIssuance
     * @return \App|C\StructType\PrepareFlightsRequest
     */
    public function setDeferredIssuance($deferredIssuance = null)
    {
        // validation for constraint: boolean
        if (!is_null($deferredIssuance) && !is_bool($deferredIssuance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($deferredIssuance, true), gettype($deferredIssuance)), __LINE__);
        }
        $this->DeferredIssuance = $deferredIssuance;
        return $this;
    }
    /**
     * Get ECouponBookCodes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfECouponBookCode|null
     */
    public function getECouponBookCodes()
    {
        return isset($this->ECouponBookCodes) ? $this->ECouponBookCodes : null;
    }
    /**
     * Set ECouponBookCodes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfECouponBookCode $eCouponBookCodes
     * @return \App|C\StructType\PrepareFlightsRequest
     */
    public function setECouponBookCodes(\App|C\ArrayType\ArrayOfECouponBookCode $eCouponBookCodes = null)
    {
        if (is_null($eCouponBookCodes) || (is_array($eCouponBookCodes) && empty($eCouponBookCodes))) {
            unset($this->ECouponBookCodes);
        } else {
            $this->ECouponBookCodes = $eCouponBookCodes;
        }
        return $this;
    }
    /**
     * Get FareInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareInfo|null
     */
    public function getFareInfo()
    {
        return isset($this->FareInfo) ? $this->FareInfo : null;
    }
    /**
     * Set FareInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FareInfo $fareInfo
     * @return \App|C\StructType\PrepareFlightsRequest
     */
    public function setFareInfo(\App|C\StructType\FareInfo $fareInfo = null)
    {
        if (is_null($fareInfo) || (is_array($fareInfo) && empty($fareInfo))) {
            unset($this->FareInfo);
        } else {
            $this->FareInfo = $fareInfo;
        }
        return $this;
    }
    /**
     * Get IncludeAllOptionalSpecialServices value
     * @return bool|null
     */
    public function getIncludeAllOptionalSpecialServices()
    {
        return $this->IncludeAllOptionalSpecialServices;
    }
    /**
     * Set IncludeAllOptionalSpecialServices value
     * @param bool $includeAllOptionalSpecialServices
     * @return \App|C\StructType\PrepareFlightsRequest
     */
    public function setIncludeAllOptionalSpecialServices($includeAllOptionalSpecialServices = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeAllOptionalSpecialServices) && !is_bool($includeAllOptionalSpecialServices)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeAllOptionalSpecialServices, true), gettype($includeAllOptionalSpecialServices)), __LINE__);
        }
        $this->IncludeAllOptionalSpecialServices = $includeAllOptionalSpecialServices;
        return $this;
    }
    /**
     * Get Offer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\OfferIn|null
     */
    public function getOffer()
    {
        return isset($this->Offer) ? $this->Offer : null;
    }
    /**
     * Set Offer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\OfferIn $offer
     * @return \App|C\StructType\PrepareFlightsRequest
     */
    public function setOffer(\App|C\StructType\OfferIn $offer = null)
    {
        if (is_null($offer) || (is_array($offer) && empty($offer))) {
            unset($this->Offer);
        } else {
            $this->Offer = $offer;
        }
        return $this;
    }
    /**
     * Get Passengers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfPassenger|null
     */
    public function getPassengers()
    {
        return isset($this->Passengers) ? $this->Passengers : null;
    }
    /**
     * Set Passengers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfPassenger $passengers
     * @return \App|C\StructType\PrepareFlightsRequest
     */
    public function setPassengers(\App|C\ArrayType\ArrayOfPassenger $passengers = null)
    {
        if (is_null($passengers) || (is_array($passengers) && empty($passengers))) {
            unset($this->Passengers);
        } else {
            $this->Passengers = $passengers;
        }
        return $this;
    }
    /**
     * Get PromoCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPromoCode()
    {
        return isset($this->PromoCode) ? $this->PromoCode : null;
    }
    /**
     * Set PromoCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $promoCode
     * @return \App|C\StructType\PrepareFlightsRequest
     */
    public function setPromoCode($promoCode = null)
    {
        // validation for constraint: string
        if (!is_null($promoCode) && !is_string($promoCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($promoCode, true), gettype($promoCode)), __LINE__);
        }
        if (is_null($promoCode) || (is_array($promoCode) && empty($promoCode))) {
            unset($this->PromoCode);
        } else {
            $this->PromoCode = $promoCode;
        }
        return $this;
    }
    /**
     * Get Segments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfSegmentBooking|null
     */
    public function getSegments()
    {
        return isset($this->Segments) ? $this->Segments : null;
    }
    /**
     * Set Segments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfSegmentBooking $segments
     * @return \App|C\StructType\PrepareFlightsRequest
     */
    public function setSegments(\App|C\ArrayType\ArrayOfSegmentBooking $segments = null)
    {
        if (is_null($segments) || (is_array($segments) && empty($segments))) {
            unset($this->Segments);
        } else {
            $this->Segments = $segments;
        }
        return $this;
    }
    /**
     * Get WebClassesCodes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfstring|null
     */
    public function getWebClassesCodes()
    {
        return isset($this->WebClassesCodes) ? $this->WebClassesCodes : null;
    }
    /**
     * Set WebClassesCodes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfstring $webClassesCodes
     * @return \App|C\StructType\PrepareFlightsRequest
     */
    public function setWebClassesCodes(\App|C\ArrayType\ArrayOfstring $webClassesCodes = null)
    {
        if (is_null($webClassesCodes) || (is_array($webClassesCodes) && empty($webClassesCodes))) {
            unset($this->WebClassesCodes);
        } else {
            $this->WebClassesCodes = $webClassesCodes;
        }
        return $this;
    }
}
